classification
Title: asyncore.file_wrapper should implement __del__ and call close there to prevent resource leaks and behave like socket.socket does.
Type: resource usage Stage:
Components: Library (Lib) Versions: Python 3.5, Python 3.4
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: amajorek, beardedp, giampaolo.rodola, python-dev, vstinner
Priority: normal Keywords: patch

Created on 2011-03-09 19:29 by amajorek, last changed 2014-07-28 23:01 by python-dev. This issue is now closed.

Files
File name Uploaded Description Edit
issue11453.patch beardedp, 2011-03-16 01:43 Adding __exit__ asyncore.file_wrapper review
Messages (7)
msg130458 - (view) Author: Aldona Majorek (amajorek) Date: 2011-03-09 19:29
asyncore.file_wrapper duplicates file descriptor of given file and closes it in it's close method.

But unlike socket.socket class it does not automatically call close when object is garbage collected.

Users of regular sockets and asyncore.dispatcher do not experience resource leaks when they forget to call self.close() in handle_close().

But people using file_dispatcher do loose file descriptor every time file_wrapper object is garbage collected without calling self.close() first.
msg131082 - (view) Author: Ben Hayden (beardedp) * Date: 2011-03-16 01:43
Adding a patch that adds an __exit__ function much like the one that socket.socket implements. Passes the test_asyncore & also doesn't raise a resource warning when I explicitly comment out some close() calls on file wrapper objects in the test.
msg137457 - (view) Author: Aldona Majorek (amajorek) Date: 2011-06-01 20:23
Adding __exit__ will not make asyncore.file_wrapper close file descriptor when garbage collected.

Here is clone of socket.py solution for the same problem.

  def close(self):
    if self.fd:
      os.close(self.fd)
      self.fd = None # or maybe self.fd = 0 will be better

  def __del__(self):
    try:
      self.close()
    except:
      # close() may fail if __init__ didn't complete
      pass
msg221742 - (view) Author: Roundup Robot (python-dev) Date: 2014-06-27 21:52
New changeset ae12a926e680 by Victor Stinner in branch '3.4':
Issue #11453: asyncore: emit a ResourceWarning when an unclosed file_wrapper
http://hg.python.org/cpython/rev/ae12a926e680
msg221743 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2014-06-27 21:54
I fixed the issue in Python 3.4 and 3.5, thanks for the report.

In Python 3.4+, it's safe to add a destructor (__del__ method): even if the object is part of a reference cycle, it will be destroyed. It's not the case in Python 2.7. I prefer to leave Python 2.7 unchanged to limit the risk of regression.
msg221745 - (view) Author: Roundup Robot (python-dev) Date: 2014-06-27 21:57
New changeset 7c9335d97628 by Victor Stinner in branch 'default':
(Merge 3.4) Issue #11453: asyncore: emit a ResourceWarning when an unclosed
http://hg.python.org/cpython/rev/7c9335d97628
msg224202 - (view) Author: Roundup Robot (python-dev) Date: 2014-07-28 23:01
New changeset 379aad232000 by Victor Stinner in branch '3.4':
Issue #11453, #18174: Fix leak of file descriptor in test_asyncore
http://hg.python.org/cpython/rev/379aad232000

New changeset 0ced2d2325fb by Victor Stinner in branch 'default':
(Merge 3.4) Issue #11453, #18174: Fix leak of file descriptor in test_asyncore
http://hg.python.org/cpython/rev/0ced2d2325fb
History
Date User Action Args
2014-07-28 23:01:59python-devsetmessages: + msg224202
2014-06-27 21:57:29python-devsetmessages: + msg221745
2014-06-27 21:54:24vstinnersetstatus: open -> closed
versions: + Python 3.4, Python 3.5, - Python 2.7, Python 3.2, Python 3.3
nosy: + vstinner

messages: + msg221743

resolution: fixed
2014-06-27 21:52:50python-devsetnosy: + python-dev
messages: + msg221742
2011-06-01 20:23:48amajoreksetmessages: + msg137457
2011-06-01 06:27:29terry.reedysetversions: - Python 2.6, Python 2.5, Python 3.1
2011-03-16 01:43:34beardedpsetfiles: + issue11453.patch

nosy: + beardedp
messages: + msg131082

keywords: + patch
2011-03-10 09:07:55giampaolo.rodolasetnosy: + giampaolo.rodola
2011-03-09 19:29:51amajorekcreate